--[[
    cratera.lua - pure-Lua Cratera-to-Lua transpiler
    Copyright (C) 2019  Soni L.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
--]]

-- This code is highly experimental and not very good

local parser = require "parser"
local luatokens = require "luatokens"
local compiler = require "compiler"

local CRATERA_SEED = nil -- TODO

local function cratera_load(reader)
    local f, s, i = parser.stream(luatokens.defs, reader)
    local nl = 1
    local otherstate = {}
    local f, s, i = parser.stream(compiler.defs, function()
        local tokens
        repeat
            local pos, state, transemsg, etoken, estate = f(s, i)
            otherstate.line = state.line
            i = pos
            if not i then return nil end
            if not state then error(transemsg) end
            tokens = {}
            for i,v in ipairs(state) do
                state[i] = nil
                tokens[i] = v
            end
        until #tokens > 0 or not transemsg
        return tokens
    end, otherstate)
    local function fn()
        function fn()
            local tokens
            repeat
                local pos, state, transemsg, etoken, estate, est = f(s, i)
                i = pos
                if not i then return nil end
                if not state then error(transemsg .. " " .. tostring(etoken)) end
                tokens = {""}
                for i,v in ipairs(state) do
                    state[i] = nil
                    tokens[i+1] = v
                end
            until #tokens > 1 or not transemsg
            return table.concat(tokens, " ")
        end
        local ret = fn()
        return string.sub(ret, 2)
    end
    return load(function()
        return fn()
    end)
end

return {load = cratera_load, CRATERA_SEED = CRATERA_SEED}
